rm(list=ls())
setwd("C:/your_folder/with_data/")		# Customize this to your local installation

library(np)
load(file="hj1.Rdata")

nb <- 399
neval <- 100
bwmethod <- "cv.ml"
bandwidth.compute <- FALSE
ckertype <- "gaussian"
ckerorder <- 2

x.lim <- range(log(datos$rasset))
x.eval <- seq(from=x.lim[1],to=x.lim[2],length=neval)

f.hat <- matrix(NA,length(tid),neval)
g <- matrix(NA,neval,length(tid))

ptm <- proc.time()
attach(datos)
################ Creating LIST of Bandwidths objects ###################
lista.bw <- as.list(parse(text=paste("bw",tid,sep="")))
lista.bwg <- as.list(parse(text=paste("bwg",tid,sep="")))
lista.bwgr <- as.list(parse(text=paste("bwgr",tid,sep="")))
#################### Estimating ALL densities ##########################
######################## as function of X ##############################
fu <- function(x,lista.bw){
    ft <- fitted(npudens(bws=eval(lista.bwg[[1]]),edat=x))
    for(ju in 2:length(lista.bw)){
        ft <- ft + fitted(npudens(bws=eval(lista.bwg[[ju]]),edat=x))
    }
    return(ft/length(lista.bwg))
}
#################### Estimating M[1] at t & s ##########################
######################## as function of X ##############################
M <- matrix(NA,length(tid),length(tid))
Mts.1 <- function(x,bwt,bws){
    ft <- fitted(npudens(bws=bwt,edat=x))
    fs <- fitted(npudens(bws=bws,edat=x))
    return(ft*fs)
}


for(jt in 1:length(tid)){
bw.t <- eval(lista.bwg[[jt]])
f.hat[jt,] <- fitted(npudens(bws=eval(lista.bwgr[[jt]]),edat=x.eval))
for(js in jt:length(tid)){
    if(jt==js){
    M[jt,js] <- sum(npksum(txdat=log(rasset[year==tid[jt]]),leave.one.out=TRUE,
                                bws=bw.t$bw,operator="convolution")$ksum)/(bw.t$nobs*bw.t$bw)^2
    }else{
    bw.s <- eval(lista.bwg[[js]])
    M[jt,js] <- integrate(Mts.1,lower=-Inf,upper=Inf
                              ,bwt=bw.t,bws=bw.s)$value
    }
}
}

M1 <- diag(diag(M))
MM <- matrix(0,dim(M)[1],dim(M)[2])
MM[upper.tri(M)] <- M[upper.tri(M)]
M.1 <- M1 + MM + t(MM)                                 # Equation (*)

M.2 <- matrix(NA,dim(M.1)[1],dim(M.1)[2])
for(jt in 1:length(tid)){
for(js in 1:length(tid)){
    M.2[jt,js] <- sum(M.1[jt,]+M.1[,js])/length(tid)   # Equation (**)
}}

M.3 <- sum(M.1)/(length(tid)^2)                        # Equation (***)

M.hat <- M.1 - M.2 + M.3                               # Equation (7)
eigen.M.hat <- eigen(M.hat)
lambda <- eigen.M.hat$values; lambda[(lambda<0)]<-0
p <- eigen.M.hat$vectors
theta <- t(t(p)*sqrt(lambda))                          # Equation (8)

    for(ir in 1:ncol(theta)){
        g[,ir] <- colSums(theta[,ir]*f.hat)/sum(theta[,ir]^2)
    }

############################# Bootstrap ################################

M.hat.boot <- array(NA,dim=c(length(tid),length(tid),nb))
f.hat.boot <- array(NA,dim=c(length(tid),neval,nb))
lambda.boot <- matrix(NA,length(tid),nb)
p.boot <- array(NA,dim=c(length(tid),length(tid),nb))
theta.boot <- array(NA,dim=c(length(tid),length(tid),nb))
g.hat.boot <- array(NA,dim=c(neval,length(tid),nb))

for(ib in 1:nb){
for(jt in 1:length(tid)){
    x.boot.t <- sample(log(rasset[year==tid[jt]]),length(log(rasset[year==tid[jt]])),replace=TRUE)
    bw.t <- npudensbw(dat=x.boot.t,bws=c(eval(lista.bwg[[jt]])$bw),bandwidth.compute=bandwidth.compute,ckertype=ckertype,ckerorder=ckerorder) 
    bw.gr.t <- npudensbw(dat=x.boot.t,bws=c(eval(lista.bwgr[[jt]])$bw),bandwidth.compute=bandwidth.compute,ckertype=ckertype,ckerorder=ckerorder) 
    f.hat.boot[jt,,ib] <- fitted(npudens(bws=bw.gr.t,edat=x.eval))
for(js in jt:length(tid)){
    if(jt==js){
    x.boot.s <- x.boot.t
    bw.s <- bw.t
    M[jt,js] <- sum(npksum(txdat=x.boot.t,
                           leave.one.out=TRUE,
                           bws=bw.t$bw,operator="convolution")$ksum)/(bw.t$nobs*bw.t$bw)^2
    }else{
    x.boot.s <- sample(log(rasset[year==tid[js]]),length(log(rasset[year==tid[js]])),replace=TRUE)
    bw.s <- npudensbw(dat=x.boot.s,bws=c(eval(lista.bwg[[js]])$bw),bandwidth.compute=bandwidth.compute,ckertype=ckertype,ckerorder=ckerorder)     
    M[jt,js] <- integrate(Mts.1,lower=-Inf,upper=Inf
                              ,bwt=bw.t,bws=bw.s)$value
    }
}
}

M1 <- diag(diag(M))
MM <- matrix(0,dim(M)[1],dim(M)[2])
MM[upper.tri(M)] <- M[upper.tri(M)]
M.1 <- M1 + MM + t(MM)                                 # Equation (*)

M.2 <- matrix(NA,dim(M.1)[1],dim(M.1)[2])
for(jt in 1:length(tid)){
for(js in 1:length(tid)){
    M.2[jt,js] <- sum(M.1[jt,]+M.1[,js])/length(tid)   # Equation (**)
}}

M.3 <- sum(M.1)/(length(tid)^2)                        # Equation (***)

M.hat.boot[,,ib] <- M.1 - M.2 + M.3                               # Equation (7)
eigen.M.hat <- eigen(M.hat.boot[,,ib])
lambda.boot[,ib] <- eigen.M.hat$values; lambda.boot[(lambda.boot[,ib]<0),ib]<-0
p.boot[,,ib] <- eigen.M.hat$vectors
theta.boot[,,ib] <- t(t(p)*sqrt(lambda.boot[,ib]))                          # Equation (8)
}
for(ib in 1:nb){
    for(ir in 1:length(tid)){
        g.hat.boot[,ir,ib] <- colSums(theta.boot[,ir,ib]*f.hat.boot[,,ib])/sum(theta.boot[,ir,ib]^2)
    }
}
save(list=ls(),file="data1.Rdata")
detach(datos)
print(proc.time() - ptm)